/***************************************************************************
 *      Mechanized Assault and Exploration Reloaded Projectfile            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef mapdownloader_mapuploadmessagehandlerH
#define mapdownloader_mapuploadmessagehandlerH

#include "game/connectionmanager.h"
#include "game/data/map/map.h"
#include "game/protocol/lobbymessage.h"
#include "mapdownloader/mapdownload.h"

#include <functional>

class IMapUploadMessageHandler : public ILobbyMessageHandler
{
protected:
	bool handleMessage (const cMultiplayerLobbyMessage&) final;

protected:
	virtual void requested (const cMuMsgRequestMap&) = 0;
	virtual void finished (const cMuMsgFinishedMapDownload&) = 0;

private:
	enum class eState
	{
		None,
		Requested
	};
	std::map<int, eState> states;
};

class cMapUploadMessageHandler final : public IMapUploadMessageHandler
{
public:
	cMapUploadMessageHandler (std::shared_ptr<cConnectionManager>, std::function<const cStaticMap*()>);

public:
	cSignal<void (int /*playerNr*/)> onRequested;
	cSignal<void (int /*playerNr*/)> onFinished;

private:
	void requested (const cMuMsgRequestMap&) override;
	void finished (const cMuMsgFinishedMapDownload&) override;

private:
	std::shared_ptr<cConnectionManager> connectionManager;
	std::function<const cStaticMap*()> mapProvider;
	std::map<int, std::unique_ptr<cMapSender>> mapSenders;
};

#endif
